(* Compile with sa-mlton/bin/mlton -runtime "ram-slop 0.9" *)

local
  fun mkRandomList n = ListAdaptive.generateRandomList n
  fun mkSortedList n = ListAdaptive.generateSortedList n

  fun play i = Int.div(i,3) + Int.mod (i,3) + 3 * Int.div(i,5) + Int.mod(i,5) + 5*Int.div (i,7) + Int.mod (i,7) + 7*Int.div (i,11) * Int.mod (i,11)  + 11*Int.div (i,13) + Int.mod (i,13) + 13*Int.div(i,17) + Int.mod (i,17) + 17*Int.div(i,19) +  Int.mod(i,19) + 19*Int.div(i,23) + Int.mod (i,23) + 23 * Int.div (i,29) + Int.mod (i,29) + 29 * Int.div (i,31) + Int.mod (i,31) 

  fun comp (i,j) = (play i) < (play j)

  fun run test  n = 
    let
      val l = mkRandomList n
    in
      if (String.compare (test,"map") = EQUAL) then
	ListAdaptive.testMap play l
      else if (String.compare (test,"reverse") = EQUAL) then
	ListAdaptive.testReverse l
      else if (String.compare (test,"reduce") = EQUAL) then
	ListAdaptive.testReduce (fn (x,y) => if play x < play y then x else y) l
      else  if (String.compare (test,"partition") = EQUAL) then
	ListAdaptive.testPartition (fn i => Int.mod (play i,2)=0) l
      else  if (String.compare (test,"filter") = EQUAL) then
	ListAdaptive.testFilter (fn i => Int.mod (play i,2)=0) l
      else if (String.compare (test,"msort") = EQUAL) then
	ListAdaptive.testMSort comp l
      else
	(
	 print ("Error: Dont' know how to run test = " ^ test ^ "\n");
	 print ("test must be map, reverse, reduce, partition, filter, or msort")
	)
    end
  
  fun runStress test n  = 
    if (String.compare (test,"reduce") = EQUAL) then
      ListAdaptive.testReduce 
	(fn (x,y) => if play x < play y then x else y) 
	(mkSortedList n)
    else 
      print "runStress:: Don't know this test.\n"

  val test = ref ""
  val nStr = ref ""
  val _ = case CommandLine.arguments () of
	    a::b::nil => (test := a; nStr := b)
	  | _ => print ("Usage: doit [map, reverse, reduce, partition, filter, msort] <input size>\n")
  val n =  Int.fromString (!nStr)

in
  val () = case n of
	     SOME x => 
	     let
	     in
	       if (String.compare (!test, "reduce-stress") = EQUAL) then
		 runStress "reduce" x
	       else
		 run (!test) x
	     end
	   | _ => print ("Usage: doit [map,reverse,partition,msort] <input size>\n")

end

