structure QSortAdaptive : 
   sig
      include APPLICATION 
      val qsort : ('a * 'a -> bool) -> 'a ListAdaptive.t -$> 'a ListAdaptive.t
   end =
struct
   structure List = ListAdaptive
   open Adaptive
   open List   

   val qsort = fn lt => afn l =>
      let
         val putM = #putM (PutMemoTable.mkPut $ ())
         val partition = List.mk_partition $ ()
         mfun qsort (l,r) =
            case get $ l of
               NIL => r
             | CONS (hd, tl) => 
                  let 
                     val (L,G) = partition (fn y => lt (y, hd)) $ tl
                  in 
                     qsort $ (L, putM $ (SOME hd, CONS (hd, qsort $ (G, r))))
                  end
      in
         qsort $ (l, putM $ (NONE, NIL))
      end

   type it = int ListAdaptive.t
   type ot = int ListAdaptive.t

   val lt : int * int -> bool = 
      fn (i1,i2) => Int.< (i1, i2)

   fun run l = Adaptive.call (qsort lt, l)
end
