(**********************************************************************
 ** auto-coerce.sig
 **
 ** Copyright 2007 Umut A. Acar, Matthew Fluet, Ruy Ley-Wild
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: The signature for coercions between (implicit) 
 ** adaptive functions and (explicit) continuation-passing-style 
 ** functions.
 **********************************************************************)

signature AUTO_COERCE =
sig
   type 'a cont = 'a -> unit
   type ('a, 'b) xfn = ('b cont * exn cont * 'a) cont
   val afn_to_xfn : ('a -$> 'b) -> ('a, 'b) xfn
   val xfn_to_afn : ('a, 'b) xfn -> ('a -$> 'b)
end
