(**********************************************************************
 ** hash-table.sig
 **
 ** Copyright 2008 Umut A. Acar, Matthew Fluet, Ruy Ley-Wild
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: The signature for hash tables
 **********************************************************************)

signature POLY_HASH_TABLE =
sig
   type ('key, 'value) t

   val new: 'key Key.t -> ('key, 'value) t
   val insert: ('key, 'value) t * 'key * 'value -> unit
   val find: ('key, 'value) t * 'key * ('value -> bool) -> 'value option
   val remove: ('key, 'value) t * 'key * ('value -> bool) -> unit
end
(*
signature HASH_TABLE_KEY =
sig
   type t
   val eq: t Eq.t
   val hash: t Hash.t
end
signature MONO_HASH_TABLE =
sig
   structure Key: HASH_TABLE_KEY
   type 'value t

   val new: unit -> 'value t
   val insert: 'value t * Key.t * 'value -> unit
   val find: 'value t * Key.t * ('value -> bool) -> 'value option
   val remove: 'value t * Key.t * ('value -> bool) -> unit
end
*)