(**********************************************************************
 ** key.sml
 **
 ** Copyright 2008 Umut A. Acar, Matthew Fluet, Ruy Ley-Wild
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: The implementation of hash-table key functions
 **********************************************************************)

structure KeyDflt :> KEY =
struct
   type 'a t = {eq: 'a Eq.t, hash: 'a Hash.t}
   val default = {eq = Eq.default, hash = Hash.default}

   val bool: bool t = default
   val exn: exn t = default
   val int: int t = default
   val list = fn _ => default
   val option = fn _ => default
   val real: real t = default
   val string: string t = default
   val sum = fn (_,_) => default
   val tuple2 = fn (_,_) => default
   val tuple3 = fn (_,_,_) => default
   val tuple4 = fn (_,_,_,_) => default
   val unit: unit t = default
   val word: word t = default
end
