(**********************************************************************
 ** key.sig
 **
 ** Copyright 2008 Umut A. Acar, Matthew Fluet, Ruy Ley-Wild
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: The signature for hash-table key functions
 **********************************************************************)

signature KEY =
sig
   type 'a t = {eq: 'a Eq.t, hash: 'a Hash.t}
   val default: 'a t

   val bool: bool t
   val exn: exn t
   val int: int t
   val list: 'a t -> 'a list t
   val option: 'a t -> 'a option t
   val real: real t
   val string: string t
   val sum: 'a t * 'b t -> ('a, 'b) Sum.t t
   val tuple2: 'a t * 'b t -> ('a * 'b) t
   val tuple3: 'a t * 'b t * 'c t -> ('a * 'b * 'c) t
   val tuple4: 'a t * 'b t * 'c t * 'd t -> ('a * 'b * 'c * 'd) t
   val unit: unit t
   val word: word t
end
