(**********************************************************************
 ** priority-queue.sig
 **
 ** Copyright 2008 Umut A. Acar, Matthew Fluet, Ruy Ley-Wild
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: The signature for priority queues
 **********************************************************************)

signature PRIORITY_QUEUE_ELT =
sig
   type t
   val cmp : t Cmp.t
end
signature PRIORITY_QUEUE =
sig
   structure Elt : PRIORITY_QUEUE_ELT
   type t

   val empty :  t
   val isEmpty : t -> bool
   val insert : t * Elt.t -> t
   val findMin : t -> Elt.t option
   val deleteMin : t -> (t * Elt.t) option
end
