(**********************************************************************
 ** result.sml
 **
 ** Copyright 2007 Umut A. Acar, Matthew Fluet, Ruy Ley-Wild
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: The implementation of adaptive function results
 **********************************************************************)

structure Result :> RESULT =
struct
   datatype 'a t = Value of 'a | Exn of exn
   fun getValue res =
      case res of
         Value v => v
       | Exn e => raise e
   fun isValue res = case res of Value _ => true | Exn _ => false
   fun isExn res = case res of Value _ => false | Exn _ => true
end
