(* WARNING: this file is automatically generated *)
structure AListNonAdaptive : ALIST_NONADAPTIVE =
struct

datatype 'a u = NIL | CONS of ('a  * 'a u NonAdaptiveMeta.Box.t)
type 'a t = 'a u NonAdaptiveMeta.Box.t
type 'a alist = 'a t

open NonAdaptive

afun mkPut () = #putM (PutMemoTable.mkPut $ ())

fun toStringList l = NonAdaptiveMeta.Box.toString (fn _ => "") l

val fromList = afn l =>
   let
      afun fl l =
         case l of 
            [] => put $ NIL
          | h::t => (put $ (CONS (h, fl $ t)))
   in
      fl $ l
   end

fun lengthLessThan n = afn l =>
   let
      afun len (m, l) =
         if m >= n
            then false
         else 
            case get $ l of
               NIL => true
             | CONS (_, t) => len $ (m + 1, t)

      val len = 
         memoCont (afn l =>
         putTh $ (afn () => len $ (0, l)))
   in
      len $ l
   end

type 'a append = 'a t * 'a t -$> 'a t

afun append (l,r) =
let
  val putM = mkPut $ ()
  mfun app l = 
    case get $ l of 
      NIL => r
    | CONS (h,t) => putM $ (h, CONS (h, app $ t))
in
  app $ l
end

type 'a rev = 'a t -$> 'a t
afun rev l = 
   let
      val putM = mkPut $ ()
      mfun revAcc (l,acc) = 
         case get $ l of
            NIL => acc
          | CONS (hd, tl) => revAcc $ (tl, putM $ (SOME hd, CONS (hd, acc)))
   in
      revAcc $ (l, putM $ (NONE, NIL))
   end

type ('a,'b) map = ('a -> 'b) -> 'a t -$> 'b t
fun map f = afn l =>
   let
      val putM = mkPut $ ()
      mfun mmap l = 
         case get $ l of
            NIL => putM $ (NONE, NIL)
          | CONS (hd, tl) => putM $ (SOME hd, CONS (f hd, mmap $ tl))
   in
      mmap $ l
   end

type ('a,'b) map_a = ('a -$> 'b) -> 'a t -$> 'b t
fun map_a f = afn l =>
   let
      val putM = mkPut $ ()
      mfun mmap l =
         case get $ l of
            NIL => putM $ (NONE, NIL)
          | CONS (hd, tl) => putM $ (SOME hd, CONS (f $ hd, mmap $ tl))
   in
      mmap $ l
   end

type 'a filter = ('a -> bool) -> 'a t -$> 'a t
fun filter p = afn l =>
   let
      val putM = mkPut $ ()
      mfun mfilter l =
         case get $ l of
            NIL => NIL
          | CONS (hd, tl) => 
	    if p hd then 
              CONS (hd, putM $ (SOME hd, mfilter $ tl))
            else 
              mfilter $ tl
   in
      putM $ (NONE, mfilter $ l)
   end

type 'a filter_a = ('a -$> bool) -> 'a t -$> 'a t
fun filter_a p = afn l =>
   let
      val putM = mkPut $ ()
      mfun mfilter l=
         case get $ l of
            NIL => NIL
          | CONS (hd, tl) => 
	    if p $ hd then 
              CONS (hd, putM $ (SOME hd, mfilter $ tl))
            else 
              mfilter $ tl
   in
      putM $ (NONE, mfilter $ l)
   end

type 'a filter2 = ('a -> bool) * ('a -> bool) -> 'a t -$> 'a t * 'a t
fun filter2 (p1, p2) = afn l =>
   let
      val putM1 = mkPut $ ()
      val putM2 = mkPut $ ()
      mfun mfilter2 l = 
         case get $ l of
            NIL => (putM1 $ (NONE, NIL), putM2 $ (NONE, NIL))
          | CONS (hd, tl) => 
	    let
              val (tl1', tl2') = mfilter2 $ tl
              val l1' =
                  if p1 hd then 
                    putM1 $ (SOME hd, CONS (hd, tl1'))
                  else 
                    tl1'
              val l2' =
                  if p2 hd
                  then 
                    putM2 $ (SOME hd, CONS (hd, tl2'))
                  else 
                    tl2'
            in
              (l1', l2')
            end
   in
     mfilter2 $ l
   end

type 'a partition = ('a -> bool) -> 'a t -$> 'a t * 'a t
fun partition_aux putM p = afn l =>
   let
      mfun mpartition l  =
         case get $ l of
            NIL => (NIL, NIL)
          | CONS (hd, tl) => 
	    let
              val (T,F) = mpartition $ tl
            in
              if p hd then 
                (CONS (hd, putM $ (Sum.INL hd, T)), F)
              else 
                (T, CONS (hd, putM $ (Sum.INL hd, F)))
            end
       val (T,F) = mpartition $ l
   in
     (putM $ (Sum.INR true, T),
      putM $ (Sum.INR false, F))
   end

fun partition p = afn l =>
   let
      val putM = mkPut $ ()
   in
      partition_aux (putM) p $ l
   end

afun mk_partition () =
   let
      val putM = mkPut $ ()
   in
      fn p => 
      partition_aux (putM) p
   end


type 'a mkSplit = unit -> 'a -> bool
type 'a reduce = 'a mkSplit -> ('a * 'a -> 'a) -> 'a -> 'a t -$> 'a NonAdaptiveMeta.Box.t
type 'a combine = 'a mkSplit -> ('a * 'a -> 'a) -> 'a t -$> 'a NonAdaptiveMeta.Box.t

fun gen_fold_aux mkRandSplit f fNil fSing = afn l =>
   let
      afun halfList (l, d) =
         let
           val putM = mkPut $ ()
           val randSplit = mkRandSplit ()
               
           afun foldRun (v,l) =
               case get $ l of
                 NIL => (v, l)
               | CONS (h, t) =>
                 let
                   val vh = f (v, h)
                 in
                   if randSplit h
                   then (vh, t)
                   else foldRun $ (vh, t)
                 end

	   mfun half l =
             case get $ l of
               NIL => NIL 
             | CONS (h, t) => 
               let
                 val (v, tt) = foldRun $ (h,t)
                 val ttt = half $ tt
               in
		 CONS(v, putM $ (SOME h, ttt))
               end
	 in
	   putM $ (NONE, half $ l)
	 end

       afun combine (l, d) = 
         if get $ ((lengthLessThan 2) $ l) 
         then case get $ l of
                NIL => fNil ()
              | CONS(h,_) => fSing h
	 else combine $ (halfList $ (l, d), d + 1)

      val combine = 
         memoCont (afn l =>  putTh $ (afn () => combine $ (l, 0)))
   in
     combine $ l
   end

fun reduce mkRandSplit f b = afn l =>
   gen_fold_aux mkRandSplit f (fn () => b) (fn x => f (b, x)) $ l
fun combine mkRandSplit f = afn l =>
   gen_fold_aux  mkRandSplit f (fn () => raise Empty) (fn x => x) $ l

end
