signature LIST_ADAPTIVE =
sig
   datatype 'a u = NIL | CONS of ('a  * 'a u AdaptiveMeta.Box.t)
   type 'a t = 'a u AdaptiveMeta.Box.t   
   type 'a alist = 'a t

   val fromList : 'a list -$> 'a t
   val lengthLessThan : int -> 'a t -$> bool AdaptiveMeta.Box.t

   val append : 'a t * 'a t -$> 'a t

   val rev : 'a t -$> 'a t

   val map : ('a -> 'b) -> 'a t -$> 'b t
   val map_a : ('a -$> 'b) -> 'a t -$> 'b t

   val filter :  ('a -> bool) -> 'a t -$> 'a t
   val filter_a : ('a -$> bool) -> 'a t -$> 'a t

   val filter2 : ('a -> bool) * ('a -> bool) -> 'a t -$> 'a t * 'a t

   val partition : ('a -> bool) -> 'a t -$> 'a t * 'a t
   val mk_partition : unit -$> (('a -> bool) -> 'a t -$> 'a t * 'a t)

   type 'a mkSplit = unit -> 'a -> bool

   val reduce : 'a mkSplit -> ('a * 'a -> 'a) -> 'a -> 'a t -$> 'a AdaptiveMeta.Box.t

   val combine : 'a mkSplit -> ('a * 'a -> 'a) -> 'a t -$> 'a AdaptiveMeta.Box.t
end
