(**********************************************************************
 ** polynomial.sml
 **
 ** Copyright 2005 Umut A. Acar
 **
 ** Written by Kanat Tangwongsan and Jorge Vittes
 **
 ** This program is distributed under the terms of the GNU General
 ** Public License as published by the Free Software Foundation.  See
 ** the LICENSE file for the terms and conditions.
 **
 ***************
 ** Description: The interface for operations on polynomial.
 **********************************************************************)

signature POLYNOMIAL =
sig
  exception badNumber
  type t 
  type poly
  val add : t * t -> t
  val sub : t * t -> t
  val mult : t * t -> t
  val scale : real * t -> t
  val shift : int * t -> t
  val eval : t * real -> real 				
  val evalsgn : t * real -> bool
  val eval0 : t -> real
  val eval0sgn : t -> bool
  val evalneginf: t -> bool
  val isZero: t -> bool

  val fromRealList : real list -> t
  val toRealList : t -> real list

  val toString': string -> t -> string
  val toString: t -> string
  val eq: t Eq.t
  val hash: t Hash.t
  val key: t Key.t

end
